/* -*- Mode: C; indent-tabs-mode: nil; tab-width: 2 -*- */

#ifndef __LIBDEJA_DUP_H__
#define __LIBDEJA_DUP_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gtk/gtk.h>

G_BEGIN_DECLS



#define DEJA_DUP_INCLUDE_LIST_KEY "/apps/deja-dup/include-list"
#define DEJA_DUP_EXCLUDE_LIST_KEY "/apps/deja-dup/exclude-list"
#define DEJA_DUP_BACKEND_KEY "/apps/deja-dup/backend"
#define DEJA_DUP_ENCRYPT_KEY "/apps/deja-dup/encrypt"
#define DEJA_DUP_LAST_RUN_KEY "/apps/deja-dup/last-run"
#define DEJA_DUP_PERIODIC_KEY "/apps/deja-dup/periodic"
#define DEJA_DUP_PERIODIC_PERIOD_KEY "/apps/deja-dup/periodic-period"
void deja_dup_update_last_run_timestamp (GError** error);
char* deja_dup_get_trash_path (void);
GFile* deja_dup_parse_dir (const char* dir);
GFile** deja_dup_parse_dir_list (GSList* dirs, int* result_length1);
void deja_dup_show_uri (GtkWindow* parent, const char* link);
void deja_dup_handle_about_uri (GtkAboutDialog* about, const char* link);
void deja_dup_handle_about_mail (GtkAboutDialog* about, const char* link);
void deja_dup_show_about (GObject* owner, GtkWindow* parent);
gboolean deja_dup_set_bus_claimed (const char* busname, gboolean claim);

static const char* DEJA_DUP_authors[] = {"Michael Terry <mike@mterry.name>", NULL};

G_END_DECLS

#endif
