/* -*- Mode: C; indent-tabs-mode: nil; c-basic-offset: 2; tab-width: 2 -*- */

#ifndef __CONFIGFOLDER_H__
#define __CONFIGFOLDER_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include "ConfigWidget.h"

G_BEGIN_DECLS


#define TYPE_CONFIG_FOLDER (config_folder_get_type ())
#define CONFIG_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIG_FOLDER, ConfigFolder))
#define CONFIG_FOLDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIG_FOLDER, ConfigFolderClass))
#define IS_CONFIG_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIG_FOLDER))
#define IS_CONFIG_FOLDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIG_FOLDER))
#define CONFIG_FOLDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIG_FOLDER, ConfigFolderClass))

typedef struct _ConfigFolder ConfigFolder;
typedef struct _ConfigFolderClass ConfigFolderClass;
typedef struct _ConfigFolderPrivate ConfigFolderPrivate;

/*
    Déjà Dup
    © 2008—2009 Michael Terry <mike@mterry.name>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
struct _ConfigFolder {
	ConfigWidget parent_instance;
	ConfigFolderPrivate * priv;
};

struct _ConfigFolderClass {
	ConfigWidgetClass parent_class;
};


ConfigFolder* config_folder_construct (GType object_type, const char* key);
ConfigFolder* config_folder_new (const char* key);
GType config_folder_get_type (void);


G_END_DECLS

#endif
