/* -*- Mode: C; indent-tabs-mode: nil; c-basic-offset: 2; tab-width: 2 -*- */

#ifndef __CONFIGNUMBER_H__
#define __CONFIGNUMBER_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include "ConfigWidget.h"

G_BEGIN_DECLS


#define TYPE_CONFIG_NUMBER (config_number_get_type ())
#define CONFIG_NUMBER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIG_NUMBER, ConfigNumber))
#define CONFIG_NUMBER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIG_NUMBER, ConfigNumberClass))
#define IS_CONFIG_NUMBER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIG_NUMBER))
#define IS_CONFIG_NUMBER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIG_NUMBER))
#define CONFIG_NUMBER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIG_NUMBER, ConfigNumberClass))

typedef struct _ConfigNumber ConfigNumber;
typedef struct _ConfigNumberClass ConfigNumberClass;
typedef struct _ConfigNumberPrivate ConfigNumberPrivate;

/*
    Déjà Dup
    © 2008—2009 Michael Terry <mike@mterry.name>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
struct _ConfigNumber {
	ConfigWidget parent_instance;
	ConfigNumberPrivate * priv;
};

struct _ConfigNumberClass {
	ConfigWidgetClass parent_class;
};


ConfigNumber* config_number_construct (GType object_type, const char* key, gint lower_bound, gint upper_bound);
ConfigNumber* config_number_new (const char* key, gint lower_bound, gint upper_bound);
gint config_number_get_lower_bound (ConfigNumber* self);
gint config_number_get_upper_bound (ConfigNumber* self);
GType config_number_get_type (void);


G_END_DECLS

#endif
