/* -*- Mode: C; indent-tabs-mode: nil; c-basic-offset: 2; tab-width: 2 -*- */

#include "ToggleGroup.h"




struct _ToggleGroupPrivate {
	Togglable* _toggle;
	GList* dependents;
};

#define TOGGLE_GROUP_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TOGGLE_GROUP, ToggleGroupPrivate))
enum  {
	TOGGLE_GROUP_DUMMY_PROPERTY,
	TOGGLE_GROUP_TOGGLE
};
static void _g_list_free_g_object_unref (GList* self);
static void toggle_group_set_toggle (ToggleGroup* self, Togglable* value);
static void __lambda0 (Togglable* t, ToggleGroup* self);
static void ___lambda0_togglable_toggled (Togglable* _sender, gpointer self);
static GObject * toggle_group_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static gpointer toggle_group_parent_class = NULL;
static void toggle_group_finalize (GObject* obj);



gboolean togglable_get_active (Togglable* self) {
	return TOGGLABLE_GET_INTERFACE (self)->get_active (self);
}


static void togglable_base_init (TogglableIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		g_signal_new ("toggled", TYPE_TOGGLABLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	}
}


GType togglable_get_type (void) {
	static GType togglable_type_id = 0;
	if (togglable_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (TogglableIface), (GBaseInitFunc) togglable_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		togglable_type_id = g_type_register_static (G_TYPE_INTERFACE, "Togglable", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (togglable_type_id, G_TYPE_OBJECT);
	}
	return togglable_type_id;
}


static void _g_list_free_g_object_unref (GList* self) {
	g_list_foreach (self, (GFunc) g_object_unref, NULL);
	g_list_free (self);
}


ToggleGroup* toggle_group_construct (GType object_type, Togglable* toggle) {
	GParameter * __params;
	GParameter * __params_it;
	ToggleGroup * self;
	g_return_val_if_fail (toggle != NULL, NULL);
	__params = g_new0 (GParameter, 1);
	__params_it = __params;
	__params_it->name = "toggle";
	g_value_init (&__params_it->value, TYPE_TOGGLABLE);
	g_value_set_object (&__params_it->value, toggle);
	__params_it++;
	self = g_object_newv (object_type, __params_it - __params, __params);
	while (__params_it > __params) {
		--__params_it;
		g_value_unset (&__params_it->value);
	}
	g_free (__params);
	return self;
}


ToggleGroup* toggle_group_new (Togglable* toggle) {
	return toggle_group_construct (TYPE_TOGGLE_GROUP, toggle);
}


void toggle_group_add_dependent (ToggleGroup* self, GtkWidget* w) {
	GtkWidget* _tmp0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (w != NULL);
	_tmp0 = NULL;
	self->priv->dependents = g_list_append (self->priv->dependents, (_tmp0 = w, (_tmp0 == NULL) ? NULL : g_object_ref (_tmp0)));
}


void toggle_group_check (ToggleGroup* self) {
	gboolean on;
	g_return_if_fail (self != NULL);
	on = togglable_get_active (self->priv->_toggle);
	{
		GList* w_collection;
		GList* w_it;
		w_collection = self->priv->dependents;
		for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
			GtkWidget* _tmp0;
			GtkWidget* w;
			_tmp0 = NULL;
			w = (_tmp0 = (GtkWidget*) w_it->data, (_tmp0 == NULL) ? NULL : g_object_ref (_tmp0));
			{
				gtk_widget_set_sensitive (w, on);
				(w == NULL) ? NULL : (w = (g_object_unref (w), NULL));
			}
		}
	}
}


Togglable* toggle_group_get_toggle (ToggleGroup* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return self->priv->_toggle;
}


static void toggle_group_set_toggle (ToggleGroup* self, Togglable* value) {
	Togglable* _tmp2;
	Togglable* _tmp1;
	g_return_if_fail (self != NULL);
	_tmp2 = NULL;
	_tmp1 = NULL;
	self->priv->_toggle = (_tmp2 = (_tmp1 = value, (_tmp1 == NULL) ? NULL : g_object_ref (_tmp1)), (self->priv->_toggle == NULL) ? NULL : (self->priv->_toggle = (g_object_unref (self->priv->_toggle), NULL)), _tmp2);
	g_object_notify ((GObject *) self, "toggle");
}


static void __lambda0 (Togglable* t, ToggleGroup* self) {
	g_return_if_fail (t != NULL);
	toggle_group_check (self);
}


static void ___lambda0_togglable_toggled (Togglable* _sender, gpointer self) {
	__lambda0 (_sender, self);
}


static GObject * toggle_group_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	ToggleGroupClass * klass;
	GObjectClass * parent_class;
	ToggleGroup * self;
	klass = TOGGLE_GROUP_CLASS (g_type_class_peek (TYPE_TOGGLE_GROUP));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = TOGGLE_GROUP (obj);
	{
		g_signal_connect (self->priv->_toggle, "toggled", (GCallback) ___lambda0_togglable_toggled, self);
	}
	return obj;
}


static void toggle_group_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ToggleGroup * self;
	gpointer boxed;
	self = TOGGLE_GROUP (object);
	switch (property_id) {
		case TOGGLE_GROUP_TOGGLE:
		g_value_set_object (value, toggle_group_get_toggle (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void toggle_group_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ToggleGroup * self;
	self = TOGGLE_GROUP (object);
	switch (property_id) {
		case TOGGLE_GROUP_TOGGLE:
		toggle_group_set_toggle (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void toggle_group_class_init (ToggleGroupClass * klass) {
	toggle_group_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ToggleGroupPrivate));
	G_OBJECT_CLASS (klass)->get_property = toggle_group_get_property;
	G_OBJECT_CLASS (klass)->set_property = toggle_group_set_property;
	G_OBJECT_CLASS (klass)->constructor = toggle_group_constructor;
	G_OBJECT_CLASS (klass)->finalize = toggle_group_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TOGGLE_GROUP_TOGGLE, g_param_spec_object ("toggle", "toggle", "toggle", TYPE_TOGGLABLE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void toggle_group_instance_init (ToggleGroup * self) {
	self->priv = TOGGLE_GROUP_GET_PRIVATE (self);
}


static void toggle_group_finalize (GObject* obj) {
	ToggleGroup * self;
	self = TOGGLE_GROUP (obj);
	(self->priv->_toggle == NULL) ? NULL : (self->priv->_toggle = (g_object_unref (self->priv->_toggle), NULL));
	(self->priv->dependents == NULL) ? NULL : (self->priv->dependents = (_g_list_free_g_object_unref (self->priv->dependents), NULL));
	G_OBJECT_CLASS (toggle_group_parent_class)->finalize (obj);
}


GType toggle_group_get_type (void) {
	static GType toggle_group_type_id = 0;
	if (toggle_group_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ToggleGroupClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) toggle_group_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ToggleGroup), 0, (GInstanceInitFunc) toggle_group_instance_init, NULL };
		toggle_group_type_id = g_type_register_static (G_TYPE_OBJECT, "ToggleGroup", &g_define_type_info, 0);
	}
	return toggle_group_type_id;
}




